diff --git a/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py b/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py
index 5ede59ca..93c45aff 100644
--- a/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py
+++ b/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py
@@ -538,46 +948,9 @@ class StartRunningQueryTest(BaseTestGenerator):
 
         else:
             manager = MagicMock()
-            manager.connection.side_effect = self.manager_connection_exception
+            manager.connection.side_effect = manager_connection_exception
 
         return manager
 
-    def __mock_assertions(self, internal_server_error_mock,
-                          make_json_response_mock):
-        if self.expect_make_json_response_to_have_been_called_with is not None:
-            make_json_response_mock.assert_called_with(
-                **self.expect_make_json_response_to_have_been_called_with)
-        else:
-            make_json_response_mock.assert_not_called()
-        if self.expect_internal_server_error_called_with is not None:
-            internal_server_error_mock.assert_called_with(
-                **self.expect_internal_server_error_called_with)
-        else:
-            internal_server_error_mock.assert_not_called()
-        if self.execute_async_return_value is not None:
-            self.connection.execute_async.assert_called_with(
-                self.expect_execute_void_called_with)
-        else:
-            self.connection.execute_async.assert_not_called()
-
-        if self.expected_logger_error is not None:
-            self.loggerMock.error.assert_called_with(
-                self.expected_logger_error)
-        else:
-            self.loggerMock.error.assert_not_called()
-
-        if self.is_begin_required:
-            self.connection.execute_void.assert_called_with('BEGIN;')
-        elif not self.is_rollback_required:
-            self.connection.execute_void.assert_not_called()
-        if self.is_rollback_required:
-            self.connection.execute_void.assert_called_with('ROLLBACK;')
-        elif not self.is_begin_required:
-            self.connection.execute_void.assert_not_called()
-
     def tearDown(self):
-        #  Reset methods to the original state
-        StartRunningQuery.is_rollback_statement_required = \
-            staticmethod(self.is_rollback_statement_required)
-        StartRunningQuery.is_rollback_statement_required = \
-            staticmethod(self.is_rollback_statement_required)
+        StartRunningQuery.is_rollback_statement_required = False
diff --git a/web/pgadmin/tools/user_management/__init__.py b/web/pgadmin/tools/user_management/__init__.py
index ac6e2f4c..4aedfe3e 100644
--- a/web/pgadmin/tools/user_management/__init__.py
+++ b/web/pgadmin/tools/user_management/__init__.py
@@ -229,7 +229,7 @@ def create():
     try:
         usr = User(email=new_data['email'],
                    roles=new_data['roles'],
-                   active=new_data['active'],
+                   active=new_data['active'] == 1,
                    password=new_data['password'])
         db.session.add(usr)
         db.session.commit()
diff --git a/web/pgadmin/utils/base_test_generator.py b/web/pgadmin/utils/base_test_generator.py
new file mode 100644
index 00000000..26cb4dbc
--- /dev/null
+++ b/web/pgadmin/utils/base_test_generator.py
@@ -0,0 +1,76 @@
+import pytest
+import six
+
+from pgadmin.utils.route import TestsGeneratorRegistry
+
+from enum import Enum
+
+
+class PostgresVersion(Enum):
+    v10 = 100000
+    v96 = 90600
+    v95 = 90500
+    v94 = 90400
+    v93 = 90300
+    v92 = 90200
+    v91 = 90100
+    v90 = 90000
+    v83 = 80323
+
+    def __gt__(self, other):
+        if self.__class__ is other.__class__:
+            return self.value > other.value
+        if type(other) == int:
+            return self.value > other
+        return NotImplemented
+
+    def __lt__(self, other):
+        if self.__class__ is other.__class__:
+            return self.value < other.value
+        if type(other) == int:
+            return self.value < other
+        return NotImplemented
+
+
+@six.add_metaclass(TestsGeneratorRegistry)
+class BaseTestGenerator(object):
+    @pytest.fixture(autouse=True)
+    def check_if_test_should_be_skipped(self, request, get_server_type,
+                                        get_server_version):
+        self.__skip_if_database(get_server_type, request)
+        self.__skip_if_postgres_version(get_server_version, request)
+
+    @pytest.fixture(autouse=True)
+    def the_real_setup(self, context_of_tests):
+        if not hasattr(self, 'setup_not_needed'):
+            self.server_information = context_of_tests['server_information']
+            self.tester = context_of_tests['test_client']
+            self.server = context_of_tests['server']
+
+            self.server_id = self.server_information["server_id"]
+
+        yield context_of_tests
+        self.tearDown()
+
+    def tearDown(self):
+        pass
+
+    def _expand_test_object(self, kwargs):
+        for key in kwargs.keys():
+            setattr(self, key, kwargs[key])
+
+    def __skip_if_database(self, get_server_type, request):
+        if request.node.get_marker('skip_databases'):
+            if get_server_type in \
+               request.node.get_marker('skip_databases').args[0]:
+                pytest.skip('cannot run in: %s' %
+                            get_server_type)
+
+    def __skip_if_postgres_version(self, get_server_version, request):
+        if request.node.get_marker('skip_if_postgres_version'):
+            versions = \
+                request.node.get_marker('skip_if_postgres_version').args[0]
+            skip_message = \
+                request.node.get_marker('skip_if_postgres_version').args[1]
+            if versions['below_version'] > get_server_version:
+                pytest.skip(skip_message)
diff --git a/web/pgadmin/utils/javascript/tests/test_javascript_bundler.py b/web/pgadmin/utils/javascript/tests/test_javascript_bundler.py
index 7030703f..b7fbf670 100644
--- a/web/pgadmin/utils/javascript/tests/test_javascript_bundler.py
+++ b/web/pgadmin/utils/javascript/tests/test_javascript_bundler.py
@@ -9,7 +9,9 @@
 
 
 import sys
-from pgadmin.utils.route import BaseTestGenerator
+
+from grappa import should
+
 from pgadmin.utils.javascript.javascript_bundler import JavascriptBundler
 from pgadmin.utils.javascript.javascript_bundler import JsState
 
@@ -19,20 +21,15 @@ else:
     from unittest.mock import patch
 
 
-class JavascriptBundlerTestCase(BaseTestGenerator):
-    """This tests that the javascript bundler tool causes the application to
-    bundle,and can be invoked before and after app start correctly"""
-
-    scenarios = [('scenario name: JavascriptBundlerTestCase', dict())]
-
-    def __init__(self, methodName='runTest'):
-        super(BaseTestGenerator, self).__init__(methodName)
-        self.mockOs = None
-        self.mockSubprocessCall = None
+class TestJavascriptBundler:
 
     @patch('pgadmin.utils.javascript.javascript_bundler.os')
     @patch('pgadmin.utils.javascript.javascript_bundler.call')
-    def runTest(self, subprocessMock, osMock):
+    def test_javascript_bundler(self, subprocessMock, osMock):
+        """
+        When the javascript bundler tool is run
+        It causes the application to bundle
+        """
         self.mockOs = osMock
         self.mockSubprocessCall = subprocessMock
 
@@ -56,7 +53,8 @@ class JavascriptBundlerTestCase(BaseTestGenerator):
 
     def _bundling_succeeds(self):
         javascript_bundler = JavascriptBundler()
-        self.assertEqual(len(self.mockSubprocessCall.method_calls), 0)
+        self.mockSubprocessCall.method_calls | \
+            should.have.length.of(0)
         self.mockSubprocessCall.return_value = 0
 
         self.mockOs.listdir.return_value = [
@@ -70,7 +68,8 @@ class JavascriptBundlerTestCase(BaseTestGenerator):
 
     def _bundling_fails_when_bundling_returns_nonzero(self):
         javascript_bundler = JavascriptBundler()
-        self.assertEqual(len(self.mockSubprocessCall.method_calls), 0)
+        self.mockSubprocessCall.method_calls | \
+            should.have.length.of(0)
         self.mockOs.listdir.return_value = []
         self.mockSubprocessCall.return_value = 99
 
@@ -115,5 +114,4 @@ class JavascriptBundlerTestCase(BaseTestGenerator):
         self.__assertState(javascript_bundler, JsState.OLD)
 
     def __assertState(self, javascript_bundler, expected_state):
-        reported_state = javascript_bundler.report()
-        self.assertEqual(reported_state, expected_state)
+        javascript_bundler.report() | should.equal(expected_state)
diff --git a/web/pgadmin/utils/route.py b/web/pgadmin/utils/route.py
index f784e534..1ccd8211 100644
--- a/web/pgadmin/utils/route.py
+++ b/web/pgadmin/utils/route.py
@@ -9,17 +9,10 @@
 
 import sys
 import traceback
-from abc import ABCMeta, abstractmethod
+from abc import ABCMeta
 from importlib import import_module
 
-import six
 from werkzeug.utils import find_modules
-from pgadmin.utils import server_utils
-
-if sys.version_info < (2, 7):
-    import unittest2 as unittest
-else:
-    import unittest
 
 
 class TestsGeneratorRegistry(ABCMeta):
@@ -75,43 +68,3 @@ class TestsGeneratorRegistry(ABCMeta):
                     import_module(module_name)
             except ImportError:
                 traceback.print_exc(file=sys.stderr)
-
-
-@six.add_metaclass(TestsGeneratorRegistry)
-class BaseTestGenerator(unittest.TestCase):
-    # Defining abstract method which will override by individual testcase.
-
-    def setUp(self):
-        super(BaseTestGenerator, self).setUp()
-        self.server_id = self.server_information["server_id"]
-        server_con = server_utils.connect_server(self, self.server_id)
-        if hasattr(self, 'skip_on_database'):
-            if 'data' in server_con and 'type' in server_con['data']:
-                if server_con['data']['type'] in self.skip_on_database:
-                    self.skipTest('cannot run in: %s' %
-                                  server_con['data']['type'])
-
-    @classmethod
-    def setTestServer(cls, server):
-        cls.server = server
-
-    @abstractmethod
-    def runTest(self):
-        pass
-
-    # Initializing app.
-    def setApp(self, app):
-        self.app = app
-
-    # Initializing test_client.
-    @classmethod
-    def setTestClient(cls, test_client):
-        cls.tester = test_client
-
-    @classmethod
-    def setDriver(cls, driver):
-        cls.driver = driver
-
-    @classmethod
-    def setServerInformation(cls, server_information):
-        cls.server_information = server_information
diff --git a/web/pgadmin/utils/server_utils.py b/web/pgadmin/utils/server_utils.py
index fa657878..d9a60449 100644
--- a/web/pgadmin/utils/server_utils.py
+++ b/web/pgadmin/utils/server_utils.py
@@ -11,6 +11,9 @@ from __future__ import print_function
 
 import json
 
+import config
+from regression.python_test_utils.test_utils import login_tester_account
+
 SERVER_URL = '/browser/server/obj/'
 SERVER_CONNECT_URL = '/browser/server/connect/'
 DUMMY_SERVER_GROUP = 10000
@@ -24,10 +27,30 @@ def connect_server(self, server_id):
     :param server_id: server id
     :type server_id: str
     """
-    response = self.tester.post(SERVER_CONNECT_URL + str(DUMMY_SERVER_GROUP) +
-                                '/' + str(server_id),
-                                data=dict(password=self.server['db_password']),
-                                follow_redirects=True)
+    return client_connect_server(self.tester, server_id,
+                                 self.server['db_password'])
+
+
+def client_connect_server(client, server_id, password):
+    """
+    This function used to connect added server
+    :param client: Flask Test client
+    :param server_id: server id
+    :param password: password to the database
+    :type server_id: str
+    """
+    response = client.post(SERVER_CONNECT_URL + str(DUMMY_SERVER_GROUP) +
+                           '/' + str(server_id),
+                           data=dict(password=password),
+                           follow_redirects=True)
+
+    if response.status_code == 401 and config.SERVER_MODE:
+        login_tester_account(client)
+        response = client.post(SERVER_CONNECT_URL + str(DUMMY_SERVER_GROUP) +
+                               '/' + str(server_id),
+                               data=dict(password=password),
+                               follow_redirects=True)
+
     assert response.status_code == 200
     response_data = json.loads(response.data.decode('utf-8'))
     return response_data
diff --git a/web/pgadmin/utils/tests/test_compile_template_name.py b/web/pgadmin/utils/tests/test_compile_template_name.py
index d6ee1288..68b5cc7a 100644
--- a/web/pgadmin/utils/tests/test_compile_template_name.py
+++ b/web/pgadmin/utils/tests/test_compile_template_name.py
@@ -6,8 +6,11 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
+
+from grappa import should
+
 from pgadmin.utils.compile_template_name import compile_template_name
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 
 
 class TestCompileTemplateName(BaseTestGenerator):
@@ -32,8 +35,9 @@ class TestCompileTemplateName(BaseTestGenerator):
         ),
     ]
 
-    def runTest(self):
+    def test_all(self, args, kwargs):
+        self._expand_test_object(kwargs)
         result = compile_template_name(
             'some/prefix', 'some_file.sql', self.server_type, self.version
         )
-        self.assertEquals(result, self.expected_return_value)
+        result | should.be.equal.to(self.expected_return_value)
diff --git a/web/pgadmin/utils/tests/test_versioned_template_loader.py b/web/pgadmin/utils/tests/test_versioned_template_loader.py
index 46fefeca..a4739a85 100644
--- a/web/pgadmin/utils/tests/test_versioned_template_loader.py
+++ b/web/pgadmin/utils/tests/test_versioned_template_loader.py
@@ -9,86 +9,26 @@
 
 import os
 
+import pytest
 from flask import Flask
+from grappa import should
 from jinja2 import FileSystemLoader
 from jinja2 import TemplateNotFound
 
 from pgadmin import VersionedTemplateLoader
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 
 
 class TestVersionedTemplateLoader(BaseTestGenerator):
-    scenarios = [
-        (
-            "Render a template when called",
-            dict(scenario=1)
-        ),
-        (
-            "Render a version 9.1 template when it is present",
-            dict(scenario=2)
-        ),
-        (
-            "Render a version 9.2 template when request for a higher version",
-            dict(scenario=3)
-        ),
-        (
-            "Render default version when version 9.0 was requested and only "
-            "9.1 and 9.2 are present",
-            dict(scenario=4)
-        ),
-        (
-            "Raise error when version is smaller than available templates",
-            dict(scenario=5)
-        ),
-        (
-            "Render a version GPDB 5.0 template when it is present",
-            dict(scenario=6)
-        ),
-        (
-            "Render a version GPDB 5.0 template when it is in default",
-            dict(scenario=7)
-        ),
-        (
-            "Raise error when version is gpdb but template does not exist",
-            dict(scenario=8)
-        )
-    ]
+    """Test Versioned template loader"""
 
-    def setUp(self):
+    @pytest.fixture(autouse=True)
+    def setup_tests(self):
+        setattr(self, 'setup_not_needed', True)
         self.loader = VersionedTemplateLoader(FakeApp())
 
-    def runTest(self):
-        if self.scenario == 1:
-            self.test_get_source_returns_a_template()
-        if self.scenario == 2:
-            # test_get_source_when_the_version_is_9_1_returns_9_1_template
-            self.test_get_source_when_the_version_is_9_1()
-        if self.scenario == 3:
-            # test_get_source_when_the_version_is_9_3_and_there_are_templates_
-            # for_9_2_and_9_1_returns_9_2_template
-            self.test_get_source_when_the_version_is_9_3()
-        if self.scenario == 4:
-            # test_get_source_when_the_version_is_9_0_and_there_are_templates_
-            # for_9_1_and_9_2_returns_default_template
-            self.test_get_source_when_the_version_is_9_0()
-        if self.scenario == 5:
-            # test_raise_not_found_exception_when_postgres_version_less_than_
-            # all_available_sql_templates
-            self.test_raise_not_found_exception()
-        if self.scenario == 6:
-            # test_get_source_when_the_version_is_gpdb_5_0_returns_gpdb_5_0_
-            # template
-            self.test_get_source_when_the_version_is_gpdb_5_0()
-        if self.scenario == 7:
-            # test_get_source_when_the_version_is_gpdb_5_0_returns_default_
-            # template
-            self.test_get_source_when_the_version_is_gpdb_5_0_returns_default()
-        if self.scenario == 8:
-            # test_raise_not_found_exception_when_the_version_is_gpdb_template
-            # _not_exist
-            self.test_raise_not_found_exception_when_the_version_is_gpdb()
-
     def test_get_source_returns_a_template(self):
+        """Render a template when called"""
         expected_content = "Some SQL" \
                            "\nsome more stuff on a new line\n"
         # For cross platform we join the SQL path
@@ -99,10 +39,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
         content, filename, up_to_dateness = self.loader.get_source(
             None, "some_feature/sql/9.1_plus/some_action.sql"
         )
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_9_1(self):
         """Render a version 9.1 template when it is present"""
@@ -117,10 +56,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None, "some_feature/sql/#90100#/some_action.sql"
         )
 
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_9_3(self):
         """Render a version 9.2 template when request for a higher version"""
@@ -133,10 +71,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None, "some_feature/sql/#90300#/some_action.sql"
         )
 
-        self.assertEqual(
-            "Some 9.2 SQL", str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        "Some 9.2 SQL" | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_9_0(self):
         """Render default version when version 9.0 was requested and only
@@ -150,18 +87,15 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None,
             "some_feature/sql/#90000#/some_action_with_default.sql")
 
-        self.assertEqual("Some default SQL", str(content).replace("\r", ""))
-        self.assertIn(sql_path, filename)
+        "Some default SQL" | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_raise_not_found_exception(self):
         """Raise error when version is smaller than available templates"""
-        try:
-            self.loader.get_source(
-                None, "some_feature/sql/#10100#/some_action.sql"
-            )
-            self.fail("No exception raised")
-        except TemplateNotFound:
-            return
+        (lambda: self.loader.get_source(
+            None, "some_feature/sql/#10100#/some_action.sql"
+        )) | should.raises(TemplateNotFound)
 
     def test_get_source_when_the_version_is_gpdb_5_0(self):
         """Render a version GPDB 5.0 template when it is present"""
@@ -177,10 +111,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             "some_feature/sql/#gpdb#80323#/some_action_with_gpdb_5_0.sql"
         )
 
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_gpdb_5_0_returns_default(self):
         """Render a version GPDB 5.0 template when it is in default"""
@@ -194,20 +127,15 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None, "some_feature/sql/#gpdb#80323#/some_action_with_default.sql"
         )
 
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_raise_not_found_exception_when_the_version_is_gpdb(self):
         """"Raise error when version is gpdb but template does not exist"""
-        try:
-            self.loader.get_source(
-                None, "some_feature/sql/#gpdb#50100#/some_action.sql"
-            )
-            self.fail("No exception raised")
-        except TemplateNotFound:
-            return
+        (lambda: self.loader.get_source(
+            None, "some_feature/sql/#gpdb#50100#/some_action.sql"
+        )) | should.raises(TemplateNotFound)
 
 
 class FakeApp(Flask):
diff --git a/web/pgadmin/utils/tests_helper.py b/web/pgadmin/utils/tests_helper.py
new file mode 100644
index 00000000..b3dd03f6
--- /dev/null
+++ b/web/pgadmin/utils/tests_helper.py
@@ -0,0 +1,76 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+import json
+
+from grappa import should
+
+from pgadmin.utils.base_test_generator import BaseTestGenerator
+
+
+class ClientTestBaseClass(BaseTestGenerator):
+    def response_to_json(self, response):
+        return json.loads(
+            response.get_data(as_text=True).replace('\n', ''))
+
+    def assert_node_json(self, json_response,
+                         _type, module_name, inode, icon_class, label):
+        assert_json_values_from_response(
+            json_response,
+            _type, module_name, inode, icon_class, label)
+
+
+def convert_response_to_json(response):
+    return json.loads(
+        response.data.decode('utf-8').replace('\n', ''))
+
+
+def assert_json_values_from_response(json_response,
+                                     _type, module_name, inode, icon_class,
+                                     label):
+    """
+    This function only works for JSON objects that look like:
+        { node:
+          {
+            module: '',
+            inode: '',
+            icon: '',
+            label: '',
+            id: ''
+          }
+        }
+    """
+    (json_response | should.have.key('node') > should.have.key('_type') >
+     should.be.equal.to(_type)
+     )
+    (json_response |
+     should.have.key('node') >
+     should.have.key('module') >
+     should.be.equal.to(module_name)
+     )
+    (json_response |
+     should.have.key('node') >
+     should.have.key('inode') >
+     should.be.equal.to(inode)
+     )
+    (json_response |
+     should.have.key('node') >
+     should.have.key('icon') >
+     should.match(icon_class)
+     )
+    json_response | should.have.key('node') > should.have.key('_pid')
+    (json_response |
+     should.have.key('node') >
+     should.have.key('label') >
+     should.be.equal.to(label)
+     )
+    json_response | should.have.key('node') > should.have.key('_id')
+    (json_response |
+     should.have.key('node') >
+     should.have.key('id') >
+     should.be.equal.to(_type + '/' + str(json_response['node']['_id'])))
diff --git a/web/regression/conftest.py b/web/regression/conftest.py
new file mode 100644
index 00000000..1f66b465
--- /dev/null
+++ b/web/regression/conftest.py
@@ -0,0 +1,35 @@
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+
+# def pytest_generate_tests(metafunc):
+#     print('\n\n\npytest_generate_tests\n\n\n')
+#     idlist = []
+#     argvalues = []
+#     for scenario in metafunc.cls.scenarios:
+#         idlist.append(scenario[0])
+#         items = scenario[1].items()
+#         argnames = [x[0] for x in items]
+#         argvalues.append(([x[1] for x in items]))
+#     metafunc.parametrize(argnames, argvalues, ids=idlist, scope="class")
+import sys
+
+
+def pytest_generate_tests(metafunc):
+    print('Generation next')
+    idlist = []
+    argvalues = []
+    argnames = []
+    print('output', file=sys.stderr)
+    for scenario in metafunc.cls.scenarios:
+        idlist.append(scenario[0])
+        items = scenario[1].items()
+        argnames = [x[0] for x in items]
+        argvalues.append(([x[1] for x in items]))
+        print('bamm', file=sys.stderr)
+    print('shebang', file=sys.stderr)
+    metafunc.parametrize(argnames, argvalues, ids=idlist, scope="class",
+                         indirect=False)
diff --git a/web/regression/feature_utils/base_feature_test.py b/web/regression/feature_utils/base_feature_test.py
index 568fc2e9..3fcb94bf 100644
--- a/web/regression/feature_utils/base_feature_test.py
+++ b/web/regression/feature_utils/base_feature_test.py
@@ -16,7 +16,7 @@ from datetime import datetime
 from copy import deepcopy
 
 import config as app_config
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 from regression.feature_utils.pgadmin_page import PgadminPage
 
 
diff --git a/web/regression/python_test_utils/test_utils.py b/web/regression/python_test_utils/test_utils.py
index 3e517b61..dbe519bc 100644
--- a/web/regression/python_test_utils/test_utils.py
+++ b/web/regression/python_test_utils/test_utils.py
@@ -15,6 +15,8 @@ import uuid
 import psycopg2
 import sqlite3
 from functools import partial
+
+import pytest
 from testtools.testcase import clone_test_with_new_id
 
 import config
@@ -38,37 +40,33 @@ def get_db_connection(db, username, password, host, port, sslmode="prefer"):
     return connection
 
 
-def login_tester_account(tester):
+def login_tester_account(http_client):
     """
     This function login the test client using env variables email and password
-    :param tester: test client
-    :type tester: flask test client object
+    :param http_client: test client
+    :type http_client: flask test client object
     :return: None
     """
     if os.environ['PGADMIN_SETUP_EMAIL'] and \
        os.environ['PGADMIN_SETUP_PASSWORD']:
         email = os.environ['PGADMIN_SETUP_EMAIL']
         password = os.environ['PGADMIN_SETUP_PASSWORD']
-        tester.post('/login', data=dict(email=email, password=password),
-                    follow_redirects=True)
+        http_client.post('/login', data=dict(email=email, password=password),
+                         follow_redirects=True)
     else:
-        from regression.runtests import app_starter
-        print("Unable to login test client, email and password not found.",
-              file=sys.stderr)
-        _cleanup(tester, app_starter)
-        sys.exit(1)
+        pytest.fail('Email and Password were not set in the environment')
 
 
-def logout_tester_account(tester):
+def logout_tester_account(http_client):
     """
     This function logout the test account
 
-    :param tester: test client
-    :type tester: flask test client object
+    :param http_client: test client
+    :type http_client: flask test client object
     :return: None
     """
 
-    response = tester.get('/logout')
+    http_client.get('/logout')
 
 
 def get_config_data():
@@ -458,12 +456,20 @@ def add_db_to_parent_node_dict(srv_id, db_id, test_db_name):
     })
 
 
-def add_schema_to_parent_node_dict(srv_id, db_id, schema_id, schema_name):
+def add_schema_to_parent_node_dict(srv_id,
+                                   db_password,
+                                   db_name,
+                                   db_id,
+                                   schema_id,
+                                   schema_name):
     """ This function stores the schema details into parent dict """
-    server_information = {"server_id": srv_id, "db_id": db_id,
-                          "schema_id": schema_id,
-                          "schema_name": schema_name}
-    regression.parent_node_dict["schema"].append(server_information)
+    server_information = {'server_id': srv_id,
+                          'db_name': db_name,
+                          'db_id': db_id,
+                          'schema_id': schema_id,
+                          'schema_name': schema_name,
+                          'db_password': db_password}
+    regression.parent_node_dict['schema'].append(server_information)
     return server_information
 
 
@@ -477,11 +483,11 @@ def create_parent_server_node(server_info):
     """
     srv_id = create_server(server_info)
     # Create database
-    test_db_name = "test_db_%s" % str(uuid.uuid4())[1:6]
+    test_db_name = 'test_db_%s' % str(uuid.uuid4())[1:6]
     db_id = create_database(server_info, test_db_name)
     add_db_to_parent_node_dict(srv_id, db_id, test_db_name)
     # Create schema
-    schema_name = "test_schema_%s" % str(uuid.uuid4())[1:6]
+    schema_name = 'test_schema_%s' % str(uuid.uuid4())[1:6]
     connection = get_db_connection(
         test_db_name,
         server_info['username'],
@@ -493,7 +499,12 @@ def create_parent_server_node(server_info):
 
     schema = regression.schema_utils.create_schema(connection, schema_name)
     return add_schema_to_parent_node_dict(
-        srv_id, db_id, schema[0], schema[1]
+        srv_id,
+        server_info['db_password'],
+        test_db_name,
+        db_id,
+        schema[0],
+        schema[1]
     )
 
 
diff --git a/web/regression/runtests.sh b/web/regression/runtests.sh
new file mode 100755
index 00000000..b4701d3b
--- /dev/null
+++ b/web/regression/runtests.sh
@@ -0,0 +1,5 @@
+#!/bin/sh
+
+web_dir=$(cd `dirname $0` && cd .. && pwd )
+export PYTHONPATH=$web_dir
+pytest $web_dir/pgadmin --json=test_result.json --resultlog=regression.log
-- 
2.17.0

